
function ExampleLecture10VideoServer()


seed = 2;

rng(seed);

TimeHorizon=1500;

% video_quality 1
phigh=0.01;
plow=0.01;

Ch = CongestionStateGeneration(phigh,plow,TimeHorizon);

figure
plot(Ch);
axis([0 TimeHorizon -0.5 1.5]);
xlabel('time');
ylabel('Congestion State');

% Actions: H, L
% States: (H,NC),(H,C),(L,NC),(L,C) = {1,2,3,4}

% We also need to explore to learn
Epsilon = 0.1;
Delta = 0;

% Q-table
Q_table = zeros(4,2); % The Q-table

state = zeros(1,TimeHorizon);
action = zeros(1,TimeHorizon);
reward = zeros(1,TimeHorizon);
video_quality = zeros(1,TimeHorizon);
explore = zeros(1,TimeHorizon);

K=2; % Number of actions

action_ntimes = zeros(4,2); % Times I selected one action

state(1)=1+Ch(1); % The agent starts in state 1
video_quality(1)=1;

alfa = 0.2; % learning rate
gamma = 0.9; % discount factor

% Rewards 
Reward_H_NC = 1;
Reward_H_C = 0;
Reward_L_NC = 0.25;
Reward_L_C = 0.75;

AcReward = 0;

for t=1:TimeHorizon-1

% To be completed
  
end

disp('Q table');
disp(Q_table);

disp('Accumulated Reward');
disp(AcReward);

figure
subplot(2,1,1); plot(Ch,'k');
axis([0 TimeHorizon -0.5 1.5]);
xlabel('time');
ylabel('Congestion');

subplot(2,1,2); plot(video_quality,'ro');
axis([0 TimeHorizon 0.5 2.5]);
xlabel('time');
ylabel('Video quality (1=High, 2=Low)');



end




% Congestion state

function [ChS]=CongestionStateGeneration(pbusy,pempty,TimeHorizon)

ChS=zeros(1,TimeHorizon);

ChS(1)=round(rand);

for t=2:TimeHorizon
    if(ChS(t-1)==1) % State Busy
        if(rand < pempty)
           ChS(t)=0; 
        else
           ChS(t)=1; 
        end
    else % State Empty
        if(rand < pbusy)
           ChS(t)=1; 
        else
           ChS(t)=0; 
        end
    end
end

end